/*++

  COPYRIGHT        (C) NEC        Corporation 1997

  All rights reserved by NEC Corporation. This program must be
  used solely for the purpose for which it was furnished by NEC
  Corporation. No part of this program may be reproduced or
  disclosed to others, in any form, without the prior written
  permission of NEC Corporation.
  Use of copyright notice does not evidence publication of this
  program.

  Author	:  		T.Muto(NEC Software Ltd.,)
  Module Name:		kmutil.h

  Abstract:
	KAMUI = Kamui is abstruction model that is ultimate interface for PowerVR.
	'kmutil.h' utilities functions for KAMUI.

  Environment:
	Microsoft Compiler.

  Notes:

  Revision History:

--*/

#if !defined(__kamui_utility_h)
#define __kamui_utility_h

#ifdef __cplusplus
extern "C" {
#endif 

#include "kamui.h"

/*++
kmuCreateTwiddledTexture

proto type:

	KMSTATUS
	kmuCreateTwiddledTexture(
			PKMDWORD		pOutputTexture,
			PKMDWORD		pInputTexture,
			KMBOOLEAN		bAutoMipMap,
			KMBOOLEAN		bDither,
			KMINT32			USize,
			KMTEXTURETYPE	nTextureType
		);

Description:
	CKM_TEXTURE_BMP`(ABGR8888)̃eNX`A
	Twiddled / Twiddled Mipmap `̃eNX`ɕϊ܂B
	bAutoMipMapTRUEw肵ꍇ́A~bv}bv̎s܂B
	bDitherTRUEw肵ꍇ́AfBUs܂B
	ӁF~bv}bvAfBU̎wsƂ
			̓eNX`f[^̓e͔j󂳂܂B

Arguments:
	OUT	pOutputTexture	ϊ̃eNX`f[^ރC̃AhXłB
	IN	pInputTexture	KM_TEXTURE_BMP`̓̓eNX`|C^łB
	IN	bAutoMipMap		IMIPMAP𐶐邩ǂw肵܂B
						TRUEw肳ꂽꍇɂ͎IMIPMAP𐶐܂B
						(o͂KM_TEXTURE_TWIDDLED_MM`ɂȂ܂)
						FALSEw肳ꂽꍇɂMIPMAP͍s܂B
						(o͂KM_TEXTURE_TWIDDLED`ɂȂ܂)
	IN	bDither			fBU邩ǂw肵܂B
						TRUEw肳ꂽꍇ̓fBU܂B
	IN	USize			eNX`̈ӂ̃eNZw肵܂B
						L̒̂ꂩw肵܂B
						KM_MAPSIZE_8
						KM_MAPSIZE_16
						KM_MAPSIZE_32
						KM_MAPSIZE_64
						KM_MAPSIZE_128
						KM_MAPSIZE_256
						KM_MAPSIZE_512
						KM_MAPSIZE_1024
	IN	nTextureType	ϊ̃eNX`̃sNZtH[}bgw肵܂B
						L̒̂ꂩw肵܂B
						KM_PIXELFORMAT_ARGB1555
						KM_PIXELFORMAT_RGB565
						KM_PIXELFORMAT_ARGB4444

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^CvATCYw肵

--*/

KMSTATUS KMAPI
kmuCreateTwiddledTexture(
	PKMDWORD		pOutputTexture,
	PKMDWORD		pInputTexture,
	KMBOOLEAN		bAutoMipMap,
	KMBOOLEAN		bDither,
	KMINT32			USize,
	KMTEXTURETYPE	nTextureType
	);


/*++
kmuConvertFBtoBMP

proto type:

	KMSTATUS
	kmuConvertFBtoBMP(
			PKMDWORD		pOutputData,
			PKMDWORD		pInputData,
			KMINT32			nWidth,
			KMINT32			nHeight,
			KMBPPMODE		nBpp
		);

Description:
	kmGetTextureŃCɓǂݏot[obt@̓eA
	Windows tJ[BMP`̃sNZf[^ƂāAɏo܂B
	ȂȀo͂ɂWindows BMP̃wb_54oCg͐܂B

Arguments:
	OUT	pOutputData		ϊ̃sNZf[^ރC̃AhXłB
	IN	pInputData		t[obt@̓e|C^łB
						kmGetTextureŁAt[obt@T[tFXւ̃fBXNv^
						w肵ēǂݏot[obt@̃sNZf[^wĂȂ
						܂BKAMUIeNX`f[^͎ws\łB
	IN	nWidth,nHeight	ǂݏot[obt@̃TCYw肵܂B
	IN	nBpp			ǂݏot[obt@̃sNZtH[}bgw肵܂B
						L̒̂ꂩw肵܂B
							KM_DSPBPP_RGB565
							KM_DSPBPP_RGB555
							KM_DSPBPP_ARGB4444
							KM_DSPBPP_ARGB1555

Result:
	KMSTATUS_SUCCESS					ǂݍݐ

--*/

KMSTATUS KMAPI
kmuConvertFBtoBMP(
		PKMDWORD		pOutputData,
		PKMDWORD		pInputData,
		KMINT32			nWidth,
		KMINT32			nHeight,
		KMBPPMODE		nBpp
		);


#ifdef __cplusplus
}
#endif 

#endif
