/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERSRISES,LTD.
*/

#ifndef _NINJA_SYS_H_
#define _NINJA_SYS_H_

/*--------------------------------------*/
/*      Target System                   */
/*--------------------------------------*/
#define _DURAL_     0
#define _SATURN_    1
#define _MD_        2
#define _PS_        3
#define _N64_       4
#define _M2_        5
#define _SET2_		6
#define _SET4_		7
#define _SET5_		8

#define _WIN32_     10
#define _WIN31_     11
#define _WINCE_     12
#define _WIN32S_    13
#define _WARP_      14
#define _PC_DOS_    15
#define _MAC_       16
#define _UNIX_      17

/*--------------------------------------*/
/*      Target CPU                      */
/*--------------------------------------*/
#define _SH1_       0
#define _SH2_       1
#define _SH3_       2
#define _SH3E_      3
#define _SH4_       4
#define _SH4E_      5
#define _I386_      6
#define _I486_      7
#define _PENTIUM_   8
#define _PENTIUM_P_ 9
#define _P_MMX_     10
#define _PENTIUM_2_ 11
#define _M68000_    12
#define _M68040_    13
#define _POWERPC_   14
#define _Rx000_     15
#define _SH_		16

/*--------------------------------------*/
/*      VIDEO System                    */
/*--------------------------------------*/
#define _3DFX_      0
#define _POWERVR_   1
#define _VIRGE_     2
#define	_ARC1_		3
#define	_IRIS_		4
#define	_COSMOS_	5
#define	_HOLLY_		5

/*--------------------------------------*/
/*      Deta Type                       */
/*--------------------------------------*/
#define _BIG_ENDIAN_    0
#define _LITTLE_ENDIAN_ 1

/*--------------------------------------*/
/*      System Configuration            */
/*--------------------------------------*/
#define _TARGET_    _SET4_
#define _CPU_       _SH4_
#define _VIDEO_     _COSMOS_
#define _ENDIAN_    _LITTLE_ENDIAN_

#if _TARGET_ != _WIN32_
#define __inline static
#define _inline	
#endif
#endif
