/**********************************************************************

	Title :			Action Module header file 
	Filename :		action.h
	Author :		Thomas Szirtes
	Revision :		1.0

	Notes :			Handles AI and scripting for Computer controlled
					objects

	Copyright :		(C) SEGA Europe 1998

  **********************************************************************/

#ifndef _ACTION_H_INCLUDED
#define _ACTION_H_INCLUDED

/*
 *	Includes
 */

#include	<ninja.h>
#include	"ftypes.h"
#include	"ship.h"


/*
 *		Function Prototypes
 */

/*--------------------------------------------------------------------------
 
  Uint16 ACTION_ReadScript(Script *s,Uint16 index, SHIPAI *shipai)
 
  Parameters:
 	s			Script
 	index		index into script
 	shipai		Ship's AI structure
 
  Returns:
 
  Notes:
 	Reads from specified position in script and then interprets data into
 	specified ship's AI structure.
 
  --------------------------------------------------------------------------*/

Uint16	ACTION_ReadScript	( Script *, Uint16, SHIPAI * );


/*--------------------------------------------------------------------------
 
  void ACTION_Ship(SHIP *ship, PERIPH_DATA *per)
 
  Parameters:
 	ship		ship structure to process
 	per			peripheral data output
 
  Returns:
 
  Notes:
 	Perform all cycles of ship AI.
 
  --------------------------------------------------------------------------*/

void	ACTION_Ship			( SHIP * , PERIPH_DATA * );

#endif