/**********************************************************************

	Title :			Display module
	Filename :		display.c
	Author :		Thomas Szirtes
	Revision :		1.0

	Notes :			Controls all the main display functions

	Copyright :		(C) SEGA Europe 1998

  **********************************************************************/

/*
 *		Includes
 */

#include	<ninja.h>
#include	"future.h"
#include	"camera.h"
#include	"ship.h"

/*
 *		Functions
 */

/*--------------------------------------------------------------------------

  void DISPLAY_Init(void)
 
  Parameters:
 	None
 
  Returns:
 
  Notes:	Initialization and Loads in textures
 
  --------------------------------------------------------------------------*/
void DISPLAY_Init();

/*--------------------------------------------------------------------------
 
  void DISPLAY_Backdrop(CAMERA *cam)
 
  Parameters:
 	cam			pointer to camera object on which to superimpose backdrop
 
  Returns:
 
  Notes:
 		Superimposes the backdrop onto the specified camera view
 
  --------------------------------------------------------------------------*/

void DISPLAY_Backdrop(CAMERA *);

/*--------------------------------------------------------------------------
 
  void DISPLAY_Map(MAP *map)
 
  Parameters:
 	Map data pointer
 	debug mode
 
  Returns:
 
  Notes:
  
  --------------------------------------------------------------------------*/
void DISPLAY_Map(MAP *, int );

/*--------------------------------------------------------------------------
 
  void DISPLAY_Ship(CAMERA *cam)
 
  Parameters:
 	ship		pointer to ship object to display
 
  Returns:
 
  Notes:
 
  --------------------------------------------------------------------------*/
void DISPLAY_Ship(SHIP *);


/*--------------------------------------------------------------------------
 
  void DISPLAY_Fire(FIRE *fire)

  Parameters:
		fire	fire object to display

  Returns:
 
  Notes:
 
  --------------------------------------------------------------------------*/
void DISPLAY_Fire(FIRE *);
