/**********************************************************************

	Title :                 File module header
	Filename :              file.h
	Author :                Thomas Szirtes
	Revision :              1.0

	Notes :                 Allows C-style byte access to GD files

	Copyright :             (C) SEGA Europe 1998

  **********************************************************************/

#include	"ftypes.h"

#ifdef USING_SET4

#ifndef _INC_H_FILE
#define	_INC_H_FILE

#include	"shinobi.h"

/*--------------------------------------------------------------------------
 
  GDFS	t_fopen(char *fname, char *attributes)

  Parameters:
		fname		pointer to filename string
		attributes	pointer to string of attributes (ignored)

  Returns:
		file handle

  Notes:
		Attempts to open a GDROM file

  --------------------------------------------------------------------------*/
GDFS	t_fopen(char *fname, char *attributes);


/*--------------------------------------------------------------------------
 
  void	t_fclose( GDFS stream )

  Parameters:
		stream		current file handle

  Returns:

  Notes:
		Closes an open file

  --------------------------------------------------------------------------*/

void	t_fclose( GDFS stream );


/*--------------------------------------------------------------------------
 
  Uint32	t_fread( Uint8 *buffer, Uint32 size, Uint32 count, GDFS stream )

  Parameters:
		buffer		pointer to destination memory area
		size		size of items to load
		count		number of items to load
		stream		current file handle

  Returns:
		number of bytes read

  Notes:
		Reads in number of data elements from a file stream

  --------------------------------------------------------------------------*/
Uint32	t_fread( Uint8 *buffer, Uint32 size, Uint32 count, GDFS stream );

#endif
#endif