/**********************************************************************

	Title :			Map Module Header 
	Filename :		map.h
	Author :		Thomas Szirtes
	Revision :		2.0

	Notes :			Responsible for reading, writing and interpreting
					the map data

	Copyright :		(C) SEGA Europe 1998

  **********************************************************************/

/*
 *		Definitions
 */

#define		MAP_VERSION_UNSUPPORTED	"Unsupported Map version"

#define		MAP_VERSION_1			-1
#define		MAP_VERSION_1_STRING	"Map format 1 - no lighting/path info"

#define		MAP_VERSION_2			-2
#define		MAP_VERSION_2_STRING	"Map format 2 - no lighting support"

#define		MAP_VERSION_3			-3
#define		MAP_VERSION_3_STRING	"Map format 3 - full implementation"


/*
 *		Function Prototypes
 */

/*--------------------------------------------------------------------------
 
  void MAP_Load( char *filename )

  Parameters:
 	filename	filename to load from
	
  Returns:
 
  Notes:
 	
  --------------------------------------------------------------------------*/

void MAP_Load(char *);

/*--------------------------------------------------------------------------
 
  void MAP_Save( char *filename )

  Parameters:
 	filename	filename to save to
	
  Returns:
 
  Notes:
 	
  --------------------------------------------------------------------------*/

void MAP_Save(char *);


/*--------------------------------------------------------------------------
 
  void MAP_Init( void )

  Parameters:
	
  Returns:
 
  Notes:
	Initialize map
 	
  --------------------------------------------------------------------------*/

void MAP_Init( void );
