/**********************************************************************

	Title :			Tools Module header
	Filename :		tools.h
	Author :		Thomas Szirtes
	Revision :		1.0

	Notes :			Filled with tools you might want but don't know
					where to put

	Copyright :		(C) SEGA Europe 1998

  **********************************************************************/

/*
 *		Function Prototypes
 */

/*void	overflow_add(Uint8); */
/*void	overflow_remove(Uint8); */

/*--------------------------------------------------------------------------
 
  void LocaltoGlobalTex(NJS_OBJECT *obj, NJS_TEXLIST *local, NJS_TEXLIST *global)
 
  Parameters:
 	obj				Object to convert textures
 	local			Old object texture list
 	global			Global texture list
 
  Returns:
 
  Notes:
 	Converts object (and children) so that materials point to global texture
 	list instead of local. ( I don't actually use this anymore )
 
  --------------------------------------------------------------------------*/
void	LocaltoGlobalTex(NJS_OBJECT *, NJS_TEXLIST *, NJS_TEXLIST *);
void	SetTextureCache(NJS_TEXLIST *);

/*--------------------------------------------------------------------------
 
  Float GenerateRandom(void)
 
  Parameters:
 
  Returns:
 
  Notes:
  
 --------------------------------------------------------------------------*/
Uint16	GenerateRandom(void);

/*--------------------------------------------------------------------------
 
  Uint8 GetBuildingShadow(Uint8 id, Sint8 *io, Sint8 *jo, Uint16 index, Uint8	orient)
 
  Parameters:
	id			identifier of building
	io			pointer to where to write i offset 
	jo			pointer to where to write j offset
	index		index into list
	orient		orientation of building (0-3)

  Returns:
	0			finished list
	1			not finished list

  Notes:
 
 --------------------------------------------------------------------------*/
Uint8	GetBuildingShadow(Uint8, Sint8 *, Sint8 *, Uint16, Uint8);
