/*
 *  Overlay Library
 *  Copyright (c) 1998 SEGA
 *  
 *      Overlay
 *
 *  Module  : Library Header File
 *  File    : sg_ov.h
 *  Create  : 1998-02-20
 *  Modify  : 1998-05-12
 *  Version : 0.41
 *  Note    :
 */
#ifndef _SG_OV_H_
#define _SG_OV_H_

#include	<sg_xpt.h>

/*	Universally Unique Identifier	*/
#ifndef UUID_DEFINED
#define UUID_DEFINED
typedef struct _UUID
{
    Uint32	Data1;
    Uint16	Data2;
    Uint16	Data3;
    Uint8	Data4[8];
} UUID;
typedef UUID Uuid;
#endif

/*	CuID̒`		*/
#define OVD_LID { \
	0xba7e0a00, 0xbda9, 0x11d1, 0x8a, 0xeb, 0x00, 0x60, 0x08, 0x95, 0x62, 0x5f\
}\

/*  Cũo[W(Ver.0.41)		*/
#define	OVD_VERSION_NO			(0x00)		/*  o[Wԍ				*/
#define	OVD_REVISION_NO			(0x41)		/*  rWԍ				*/

/*	G[R[h	*/
typedef enum {
	OVE_ERR_OK				= 0,		/*  I					*/
	OVE_ERR_INVALID_FORMAT	= -1,		/*  sȃtH[}bg			*/
	OVE_ERR_INVALID_LIB_ID	= -2,		/*  sȃCuID			*/
	OVE_ERR_INVALID_LIB_HDL	= -3		/*  sȃCunh	*/
} OVE_ERR;


/*	Cunh	*/
typedef struct {
	struct _ov_lif	*lif;			/*	CuC^tF[X			*/
	Uint8			ver;			/*	o[Wԍ						*/
	Uint8			revi;			/*	rWԍ						*/
	Sint16			rsv1;			/*	\ 1								*/
	Sint32			rsv2;			/*	\ 2								*/
	Sint32			rsv3;			/*	\ 3								*/
	UUID    		lid;			/*	CuID						*/
} OVS_LIB_OBJ;
typedef OVS_LIB_OBJ *OVLIB;

/*	eCuK쐬郉CuC^tF[X֐  				*/
typedef struct _ov_lif {
	void (*QueryInterface)();		/*		for COM compatibility			*/
	void (*AddRef)();				/*		for COM compatibility			*/
	void (*Release)();				/*		for COM compatibility			*/
	void (*Init)(OVLIB ovl);		/*									*/
	void (*Finish)(OVLIB ovl);		/*		I						*/
	void (*Exec)(OVLIB ovl);		/*		s							*/
} OVS_LIB_IF;
typedef OVS_LIB_IF *OVLIB_IF;

/***
*		sW[̂߂̊֐
***/

/*	sW[nh	*/
typedef struct {
	Sint32	rsv[8];
	OVS_LIB_OBJ libobj[1];
} OVS_MDL_OBJ;
typedef OVS_MDL_OBJ *OVMDL;

/***
*			Cû߂̒`
***/

/*	NeBJZNV	*/
typedef Sint32 OV_CS;

/*	CuǗe[uւ̃|C^̃AhX	*/
#define	OVD_LIBTBL_ADR_PTR	(0x8C00FFF0)
/*	CuǗe[u̍őo^ւ̃AhX	*/
#define	OVD_LIBTBL_ADR_MAX	(0x8C00FFF4)
/*	CuǗe[ũAhX	*/
#define	OVD_DEF_LIBTBL_ADR	(0x8C00FC00)

/*	CuǗe[u̍őo^	*/
#define	OVD_DEF_LIBTBL_MAX	(120)

/*	CuǗe[u	*/
typedef struct {
	Sint32	nlib;				/* o^Ă郉Cu				*/
	Sint32	rsv1;				/* \P									*/
	struct {
		OVLIB	lib;			/* Cunh						*/
		Sint32	ref;			/* QƃJE^								*/
	} entry[1];
} OVS_LIBTBL;

/***
*		֐錾
***/

/*	Cunh̎擾												*/
OVLIB ovLibOpen(UUID *lid);
/*	Cunh̊J												*/
void ovLibClose(UUID *lid);
/*	W[t@C̓ǂݍ											*/
OVE_ERR ovMdlEntryTbl(OVMDL ovmdl);
/*	W[t@C̊J												*/
OVE_ERR ovMdlDeleteTbl(OVMDL ovmdl);
/*  sW[̎s													*/
Sint32 ovMdlExec(OVMDL ovmdl);

/*  CuC^tF[X̎擾											*/
OVLIB_IF ovLibGetLibIf(OVLIB lib);
/*  Cũo[W̎擾											*/
void ovLibGetVersion(OVLIB lib, Uint8 *ver, Uint8 *revi);
/*  CuID̎擾														*/
UUID *ovLibGetUuid(OVLIB lib);

/*  CuǗCȕ (ʏgpȂj						*/
void ovInit(void *ovltbl, Sint32 nlib);
/*  CuǗCȕI (ʏgpȂj					*/
void ovFinish(void);
/*	Cunh̓o^												*/
OVE_ERR ovLibEntryTbl(OVLIB lib);
/*	Cunh̍폜												*/
OVE_ERR ovLibDeleteTbl(OVLIB lib);

#endif     /*  _SG_OV_H_	*/
